#include "../include/asset_mgr.hpp"
#include "include/paco.hpp"
#include <stdio.h>

using namespace JabyEngine;

// Do we want this namespace?
// Do we want Paco to be HERE?!
static object::Paco paco;

static void setup() {
    Assets::Main::load();
    paco.setup();
}

static void update() {
    paco.update();
}

static void render() {
    paco.render();
}

void main() {
    setup();

    while(true) {
        update();
        GPU::swap_buffers_vsync(1);
        render();
    }
}